//*********************************************************************
//    Function Block 1: Analog Input	(Slot 1)
//*********************************************************************

#ifndef func_upper_value
#define func_upper_value			func_pv_scale_upper_value
#define func_lower_value			func_pv_scale_lower_value
#endif

#ifndef BLOCK_MODE_AUTO
#define	BLOCK_MODE_AUTO			0x08
#define BLOCK_MODE_MAN         		0x10
#define	BLOCK_MODE_OUT_OF_SERVICE	0x80
#endif

BLOCK function_block_1
{
	TYPE FUNCTION;
	NUMBER	1;
}

func1_AI_blk_reserve		LIKE VARIABLE	phys_blk_reserve
{
}

VARIABLE func1_AI_blk_object
{
	LABEL		[blk_block_object];
	HELP		[blk_block_object_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	2,	[blk_block_object_FUNCTION]	}
	}
	HANDLING	READ;
}

VARIABLE func1_AI_blk_parent_class
{
	LABEL		[blk_parent_class];
	HELP		[func_blk_parent_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	1,	[func_blk_parent_class_INPUT]	}
	}
	HANDLING	READ;
}

VARIABLE func1_AI_blk_class
{
	LABEL		[blk_class];
	HELP		[func_blk_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	1,	[func_blk_class_AI]	}
	}
	HANDLING	READ;
}

func1_AI_blk_dd_reference		LIKE VARIABLE	phys_blk_dd_reference
{
}

func1_AI_blk_dd_rev			LIKE VARIABLE	phys_blk_dd_rev
{
}

func1_AI_blk_profile			LIKE VARIABLE	phys_blk_profile
{
}

func1_AI_blk_profile_rev		LIKE VARIABLE	phys_blk_profile_rev
{
}

func1_AI_blk_execution_time		LIKE VARIABLE	phys_blk_execution_time
{
}

func1_AI_blk_num_parameters		LIKE VARIABLE	phys_blk_num_parameters
{
}

func1_AI_blk_index_view_1		LIKE VARIABLE	phys_blk_index_view_1
{
}

func1_AI_blk_num_view_lists		LIKE VARIABLE	phys_blk_num_view_lists
{
}

func1_AI_st_rev				LIKE VARIABLE	phys_st_rev
{
}

func1_AI_tag_desc			LIKE VARIABLE	phys_tag_desc
{
}

func1_AI_strategy			LIKE VARIABLE	phys_strategy
{
}

func1_AI_alert_key			LIKE VARIABLE	phys_alert_key
{
}

VARIABLE func1_AI_target_mode
{
	LABEL		[target_mode];
	HELP		[target_mode_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	BLOCK_MODE_AUTO;
		{	0x08,	[mode_AUTO]		},
		{	0x10,	[mode_MAN]		},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ & WRITE;
}

VARIABLE func1_AI_actual_mode
{
	LABEL		[actual_mode];
	HELP		[actual_mode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	BLOCK_MODE_AUTO;
		{	0x08,	[mode_AUTO]		},
		{	0x10,	[mode_MAN]		},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ;
}

VARIABLE func1_AI_permitted_mode
{
	LABEL		[permitted_mode];
	HELP		[permitted_mode_help];
	CLASS		CONTAINED;
	TYPE		BIT_ENUMERATED (1)
	{
		DEFAULT_VALUE	BLOCK_MODE_AUTO;
		{	0x08,	[mode_AUTO]		},
		{	0x10,	[mode_MAN]		},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ;
}

VARIABLE func1_AI_normal_mode
{
	LABEL		[normal_mode];
	HELP		[normal_mode_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	BLOCK_MODE_AUTO;
		{	0x08,	[mode_AUTO]		},
		{	0x10,	[mode_MAN]		},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ;
}

func1_AI_current_state_alarm_sum	LIKE VARIABLE	phys_current_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x0200,	[limit_state_HI_HI]	},
		{	0x0400,	[limit_state_HI]	},
		{	0x0800,	[limit_state_LO_LO]	},
		{	0x1000,	[limit_state_LO]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}

}

func1_AI_unacknowledged_state_alarm_sum	LIKE VARIABLE	phys_unacknowledged_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x0200,	[limit_state_HI_HI]	},
		{	0x0400,	[limit_state_HI]	},
		{	0x0800,	[limit_state_LO_LO]	},
		{	0x1000,	[limit_state_LO]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
}

func1_AI_unreported_state_alarm_sum	LIKE VARIABLE	phys_unreported_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x0200,	[limit_state_HI_HI]	},
		{	0x0400,	[limit_state_HI]	},
		{	0x0800,	[limit_state_LO_LO]	},
		{	0x1000,	[limit_state_LO]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
}

func1_AI_disabled_state_alarm_sum	LIKE VARIABLE	phys_disabled_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x0200,	[limit_state_HI_HI]	},
		{	0x0400,	[limit_state_HI]	},
		{	0x0800,	[limit_state_LO_LO]	},
		{	0x1000,	[limit_state_LO]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
}

//---------------------------------------------------------------------
//    Function Block 1:  Analog Input	Additional Parameter
//---------------------------------------------------------------------

VARIABLE func1_AI_out_value
{
	LABEL		[func_out_value];
	HELP		[func_ai_out_value_help];
	CLASS		OUTPUT & DYNAMIC;
	TYPE		FLOAT
	{
                DEFAULT_VAL_FUNC1_AI
                DISPLAY_FORMAT  FIXED_DISPLAY_FORMAT(func1_AI_out_decimal_point)
        }
	HANDLING
		IF (func1_AI_target_mode == BLOCK_MODE_MAN)
		{
			READ & WRITE;
		}
		ELSE {
			READ;
		}
}

VARIABLE func1_AI_out_status
{
	LABEL		[func_out_value_with_status_quality];
	HELP		[func_out_status_help];
	CLASS		OUTPUT & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0x20;
		__FF_STATUS_VALUES
	}
	HANDLING
		IF (func1_AI_target_mode == BLOCK_MODE_MAN)
		{
			READ & WRITE;
		}
		ELSE {
			READ;
		}
}

VARIABLE func1_AI_pv_upper_range_value
{
	LABEL		[func_pv_scale_upper_value];
	HELP		[func_pv_scale_upper_value_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_UPPER_VAL_FUNC1_AI
	        DISPLAY_FORMAT  FIND_PV_DISPLAY_FORMAT(func1_AI_channel)
        }
	HANDLING	READ & WRITE;
        CONSTANT_UNIT   FIND_DEFAULT_UNIT(func1_AI_channel)
}

VARIABLE func1_AI_pv_lower_range_value
{
	LABEL		[func_pv_scale_lower_value];
	HELP		[func_pv_scale_lower_value_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
//req22_12		DEFAULT_LOWER_VAL_FUNC1_AI;
		DEFAULT_LOWER_VAL_FUNC1_AI
		DISPLAY_FORMAT  FIND_PV_DISPLAY_FORMAT(func1_AI_channel)
        }
	HANDLING	READ & WRITE;
        CONSTANT_UNIT   FIND_DEFAULT_UNIT(func1_AI_channel)
}

VARIABLE func1_AI_out_upper_range_value
{
	LABEL		[func_upper_value];
	HELP		[func_out_scale_upper_value_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_UPPER_VAL_FUNC1_AI
        	DISPLAY_FORMAT  FIXED_DISPLAY_FORMAT(func1_AI_out_decimal_point)
        }
	HANDLING	READ & WRITE;
}

VARIABLE func1_AI_out_lower_range_value
{
	LABEL		[func_lower_value];
	HELP		[func_out_scale_lower_value_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_LOWER_VAL_FUNC1_AI
        	DISPLAY_FORMAT  FIXED_DISPLAY_FORMAT(func1_AI_out_decimal_point)
        }
	HANDLING	READ & WRITE;
}

VARIABLE func1_AI_out_unit
{
	LABEL		[digital_units];
	HELP		[digital_units_help];
	CLASS		CONTAINED & SERVICE;
 	TYPE		ENUMERATED (2)
    	{
            DEFAULT_VALUE FIND_DETAIL_UNIT(func1_AI_channel)


            IF (func1_AI_channel == CHANNEL1)
            {

	      IF ((trans_fluid_phase == 0) || (trans_fluid_phase == 1))
	      {
                { 1342, [unit_1342],	[unit_1342_help]	},	/* %    */
		{ 1511,	[unit_1511],	[unit_1511_help]	},	/* 210	cm/s     */
		{ 1512,	[unit_1512],	[unit_1512_help]	},	/* 211	cm/min   */
		{ 1513,	[unit_1513],	[unit_1513_help]	},	/* 212	cm/h     */
		{ 1514,	[unit_1514],	[unit_1514_help]	},	/* 213	cm/d     */
                { 1577, [unit_1577],	[unit_1577_help]	},      /* 186	ml/s  XXX */
		{ 1563,	[unit_1563],	[unit_1563_help]	},	/* 215	ml/min    */
		{ 1578,	[unit_1578],	[unit_1578_help]	},	/* 216	ml/h      */
		{ 1347,	[unit_1347],	[unit_1347_help]	},	/* 28	m/s       */
		{ 1348,	[unit_1348],	[unit_1348_help]	},	/* 131	m/min     */
		{ 1349,	[unit_1349],	[unit_1349_help]	},	/* 19	m/h       */
		{ 1350,	[unit_1350],	[unit_1350_help]	},	/* 29	m/d       */
		{ 1351,	[unit_1351],	[unit_1351_help]	},	/* 24	l/s        */
		{ 1352,	[unit_1352],	[unit_1352_help]	},	/* 17	l/min      */
		{ 1353,	[unit_1353],	[unit_1353_help]	},	/* 138	l/h        */
		{ 1354,	[unit_1354],	[unit_1354_help]	},	/* 214	l/d        */
		{ 1356,	[unit_1356],	[unit_1356_help]	},	/* 26	ft/s      */
		{ 1357,	[unit_1357],	[unit_1357_help]	},	/* 15	ft/min    */
		{ 1358,	[unit_1358],	[unit_1358_help]	},	/* 130	ft/h      */
		{ 1359,	[unit_1359],	[unit_1359_help]	},	/* 27	ft/d      */
		{ 1362,	[unit_1362],	[unit_1362_help]	},	/* 22	usgal/s    */
		{ 1363,	[unit_1363],	[unit_1363_help]	},	/* 16	usgal/min  */
		{ 1364,	[unit_1364],	[unit_1364_help]	},	/* 136	usgal/h    */
		{ 1365,	[unit_1365],	[unit_1365_help]	},	/* 235	usgal/d    */
		{ 1367,	[unit_1367],	[unit_1367_help]	},	/* 137	Impgal/s   */
		{ 1368,	[unit_1368],	[unit_1368_help]	},	/* 18	Impgal/min */
		{ 1369,	[unit_1369],	[unit_1369_help]	},	/* 30	Impgal/h   */
		{ 1370,	[unit_1370],	[unit_1370_help]	},	/* 31	Impgal/d   */
		{ 1371,	[unit_1371],	[unit_1371_help]	},	/* 132	bbl/s      */
		{ 1372,	[unit_1372],	[unit_1372_help]	},	/* 133	bbl/min    */
		{ 1373,	[unit_1373],	[unit_1373_help]	},	/* 134	bbl/h      */
		{ 1374,	[unit_1374],	[unit_1374_help]	},	/* 135	bbl/d      */
		{ 1633,	[unit_1633],	[unit_1633_help]	},	/* 221	hl/s       */
		{ 1634,	[unit_1634],	[unit_1634_help]	},	/* 222	hl/min     */
		{ 1635,	[unit_1635],	[unit_1635_help]	},	/* 223	hl/h       */
		{ 1636,	[unit_1636y],	[unit_1636y_help]	},	/* 224	hl/d       */
                { 1995, func1_AI_out_unit_text, "Textual unit" }
	      }
	      ELSE
	      {
	        IF (trans_fluid_phase == 2)
	        {
                  { 1342, [unit_1342],	[unit_1342_help]	},	/* %    */
		  { 1588,	[unit_1588],	[unit_1588_help]	},	/* 246	Nm/s      */
		  { 1589,	[unit_1589],	[unit_1589_help]	},	/* 241	Nm/min    */
		  { 1590,	[unit_1590],	[unit_1590_help]	},	/* 121	Nm/h      */
		  { 1591,	[unit_1591y],	[unit_1591y_help]	},	/* 247	Nm/d      */
		  { 1592,	[unit_1592],	[unit_1592_help]	},	/* 248	Nl/s       */
		  { 1593,	[unit_1593],	[unit_1593_help]	},	/* 242	Nl/min     */
		  { 1594,	[unit_1594],	[unit_1594_help]	},	/* 122	Nl/h       */
		  { 1595,	[unit_1595y],	[unit_1595_help]	},	/* 249	Nl/d       */
                  { 1995, func1_AI_out_unit_text, "Textual unit" }
	        }
	        ELSE
	        {
	          IF (trans_fluid_phase == 3)
	          {
                    { 1342, 	[unit_1342],	[unit_1342_help]	},	/* %    */
		    { 1596,	[unit_1596],	[unit_1596_help]	},	/* 200	Sm/s      */
		    { 1597,	[unit_1597y],	[unit_1597y_help]	},	/* 201	Sm/min    */
		    { 1598,	[unit_1598y],	[unit_1598y_help]	},	/* 202	Sm/h      */
		    { 1599,	[unit_1599y],	[unit_1599y_help]	},	/* 203	Sm/d      */
		    { 1600,	[unit_1600],	[unit_1600_help]	},	/* 204	Sl/s       */
		    { 1601,	[unit_1601],	[unit_1601_help]	},	/* 205	Sl/min     */
		    { 1602,	[unit_1602],	[unit_1602_help]	},	/* 206	Sl/h       */
		    { 1603,	[unit_1603],	[unit_1603_help]	},	/* 207	Sl/d       */
		    { 1604,	[unit_1604y],	[unit_1604y_help]	},	/* 208	scf/s      */
		    { 1360,	[unit_1360],	[unit_1360y_help]	},	/* 123	scf/min    */
		    { 1361,	[unit_1361],	[unit_1361y_help]	},	/* 240	scf/h      */
		    { 1605,	[unit_1605y],	[unit_1605y_help]	},	/* 209	scf/d      */
		    { 1524, [unit_1524y],   [unit_1524y_help]	},	/* 190	sgal/minXXX*/
		    { 1525, [unit_1525y],   [unit_1525y_help]	},	/* 191	sgal/h  XXX*/
                    { 1995, func1_AI_out_unit_text, "Textual unit" }
	          }
	        }
	      }

            }
            ELSE
            {
                { 1342, [unit_1342],	[unit_1342_help]	}, /* %    */
		{ 1326,	[unit_1326],	[unit_1326_help]	}, /* 217	t/s        */
		{ 1327,	[unit_1327],	[unit_1327_help]	}, /* 77	t/min      */
		{ 1328,	[unit_1328],	[unit_1328_help]	}, /* 78	t/h        */
		{ 1329,	[unit_1329],	[unit_1329_help]	}, /* 79	t/d        */
		{ 1322,	[unit_1322],	[unit_1322_help]	}, /* 73	kg/s       */
		{ 1323,	[unit_1323],	[unit_1323_help]	}, /* 74	kg/min     */
		{ 1324,	[unit_1324],	[unit_1324_help]	}, /* 75	kg/h       */
		{ 1325,	[unit_1325],	[unit_1325_help]	}, /* 76	kg/d       */
		{ 1330,	[unit_1330],	[unit_1330_help]	}, /* 80	lb/s       */
		{ 1331,	[unit_1331],	[unit_1331_help]	}, /* 81	lb/min     */
		{ 1332,	[unit_1332],	[unit_1332_help]	}, /* 82	lb/h       */
		{ 1333,	[unit_1333],	[unit_1333_help]	}, /* 83	lb/d       */
		{ 1318,	[unit_1318],	[unit_1318_help]	}, /* 70	g/s        */
		{ 1319,	[unit_1319],	[unit_1319_help]	}, /* 71	g/min      */
		{ 1320,	[unit_1320],	[unit_1320_help]	}, /* 72	g/h        */
		{ 1321,	[unit_1321],	[unit_1321_help]	}, /* 218	g/d        */
		{ 1334,	[unit_1334],	[unit_1334_help]	}, /* 219	Ston/s     */
		{ 1335,	[unit_1335],	[unit_1335_help]	}, /* 84	Ston/min   */
		{ 1336,	[unit_1336],	[unit_1336_help]	}, /* 85	Ston/h     */
		{ 1337,	[unit_1337],	[unit_1337_help]	}, /* 86	Ston/d     */
		{ 1338,	[unit_1338],	[unit_1338_help]	}, /* 220	Lton/s     */
		{ 1339,	[unit_1339],	[unit_1339_help]	}, /* 243	Lton/min   */
		{ 1340,	[unit_1340],	[unit_1340_help]	}, /* 87	Lton/h     */
		{ 1341,	[unit_1341],	[unit_1341_help]	}, /* 88	Lton/d     */
		{ 1526, [unit_1526y],	[unit_1526y_help]	}, /* 192	mg/s   XXX */
		{ 1527, [unit_1527y],	[unit_1527y_help]	}, /* 193	mg/min XXX */
		{ 1528, [unit_1528y],	[unit_1528y_help]	}, /* 194	mg/h   XXX */
		{ 1607, [unit_1607y],   [unit_1607y_help]	}, /* 187	oz/min XXX */
		{ 1608, [unit_1608y],   [unit_1608y_help]	}, /* 188	oz/h   XXX */
                { 1995, func1_AI_out_unit_text, "Textual unit" }
            }
	}
}



VARIABLE func1_AI_out_decimal_point
{
	LABEL		[decimal_point];
	HELP		[decimal_point_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	2;
		{	0,   "0"	},
		{	1,   "1"	},
		{	2,   "2"	},
		{	3,   "3"	},
		{	4,   "4"	},
		{	5,   "5"	},
		{	6,   "6"	}
	}
	HANDLING	READ & WRITE;
}

//req22_12VARIABLE func1_AI_dummy
//req22_12{
//req22_12	LABEL		[dummywertx];
//req22_12	HELP		[dummy_help];
//req22_12	CLASS		OUTPUT & DYNAMIC;
//req22_12	TYPE		FLOAT
//req22_12	{
//req22_12	        func1_AI_out_value
//req22_12//req18_12        func1_AI_out_value, func1_AI_out_value,
//req22_12	}
//req22_12	HANDLING	READ & WRITE;
//req22_12}

//--------------------------------------------

VARIABLE func1_AI_lin_type
{
	LABEL		[trans_lin_type];
	HELP		[trans_lin_type_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
        { 0,    "Direct"    "|de|Direkt"},
        { 1,    "Indirect"  "|de|Indirekt" }
    }
	HANDLING	READ & WRITE;


//req18_12    POST_EDIT_ACTIONS
//req18_12    {
//req18_12        DEFINITION
//req18_12        {
//req18_12            if (func1_AI_channel == CHANNEL1)
//req18_12            {
//req18_12                func1_AI_out_unit = 1349; /* VF m/h */
//req18_12            }
//req18_12            else
//req18_12            {
//req18_12                func1_AI_out_unit = 1328; /* MF t/h */
//req18_12            }
//req18_12        }
//req18_12    }
}

VARIABLE func1_AI_channel
{
	LABEL		[func_channel];
	HELP		[func_channel_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
        DEFAULT_VALUE   CHANNEL1;
        { CHANNEL1, "Volume Flow" "|de|Volumenflu"},
        { CHANNEL2, "Mass Flow" "|de|Massenflu"}
	}
    HANDLING    READ & WRITE;

//req18_12    POST_EDIT_ACTIONS
//req18_12    {
//req18_12        DEFINITION
//req18_12        {
//req18_12            if (func1_AI_channel == CHANNEL1)
//req18_12            {
//req18_12                func1_AI_out_unit = 1349; /* m/h */
//req18_12            }
//req18_12            else
//req18_12            {
//req18_12                func1_AI_out_unit = 1328; /* MF t/h */
//req18_12            }
//req18_12        }
//req18_12    }
}

VARIABLE func1_AI_pv_ftime
{
	LABEL		[func_pv_ftime];
	HELP		[func_pv_ftime_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
		MIN_VALUE	0.0;
		MAX_VALUE	100.0;
	}
	CONSTANT_UNIT	[sec];
	HANDLING	READ & WRITE;
}

VARIABLE func1_AI_hi_hi_lim
{
	LABEL		[limit_hi_hi];
	HELP		[limit_hi_hi_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
        DEFAULT_VALUE   INF_P;
        DISPLAY_FORMAT  FIXED_DISPLAY_FORMAT(func1_AI_out_decimal_point)
    }
	HANDLING	READ & WRITE;
}

VARIABLE func1_AI_hi_lim
{
	LABEL		[limit_hi];
	HELP		[limit_hi_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
        DEFAULT_VALUE   INF_P;
        DISPLAY_FORMAT  FIXED_DISPLAY_FORMAT(func1_AI_out_decimal_point)
    }
	HANDLING	READ & WRITE;
}


VARIABLE func1_AI_lo_lim
{
	LABEL		[limit_lo];
	HELP		[limit_lo_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
        DEFAULT_VALUE   INF_N;
        DISPLAY_FORMAT  FIXED_DISPLAY_FORMAT(func1_AI_out_decimal_point)
    }
	HANDLING	READ & WRITE;
}

VARIABLE func1_AI_lo_lo_lim
{
	LABEL		[limit_lo_lo];
	HELP		[limit_lo_lo_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
        DEFAULT_VALUE   INF_N;
        DISPLAY_FORMAT  FIXED_DISPLAY_FORMAT(func1_AI_out_decimal_point)
    }
	HANDLING	READ & WRITE;
}

VARIABLE func1_AI_alarm_hys
{
	LABEL		[limit_hysteresis];
	HELP		[limit_hysteresis_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
        DEFAULT_VALUE 0.0;
        DISPLAY_FORMAT  FIXED_DISPLAY_FORMAT(func1_AI_out_decimal_point)
    }
	HANDLING	READ & WRITE;
}

VARIABLE func1_AI_hi_hi_alm_unacknowledged
{
	LABEL		[limit_alarm_unacknowledged];
	HELP		[limit_alarm_unacknowledged_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE func1_AI_hi_hi_alm_state
{
	LABEL		[limit_state];
	HELP		[limit_hi_hi_state_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0,	[limit_state_NO_ALARM]	},
		{	1,	[limit_state_HI_HI]		}
	}
	HANDLING	READ;
}

VARIABLE func1_AI_hi_hi_alm_time_stamp
{
	LABEL		[limit_time_stamp];
	HELP		[limit_time_stamp_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		TIME;
	HANDLING	READ;
}

VARIABLE func1_AI_hi_hi_alm_subcode
{
	LABEL		[limit_subcode];
	HELP		[limit_hi_hi_subcode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE func1_AI_hi_hi_alm_value
{
	LABEL		[limit_alarm_value];
	HELP		[limit_hi_hi_alarm_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}

VARIABLE func1_AI_hi_alm_unacknowledged
{
	LABEL		[limit_warn_unacknowledged];
	HELP		[limit_warn_unacknowledged_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE func1_AI_hi_alm_state
{
	LABEL		[limit_state];
	HELP		[limit_hi_state_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0,	[limit_state_NO_WARNING]	},
		{	1,	[limit_state_HI]		}
	}
	HANDLING	READ;
}

VARIABLE func1_AI_hi_alm_time_stamp
{
	LABEL		[limit_time_stamp];
	HELP		[limit_time_stamp_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		TIME;
	HANDLING	READ;
}

VARIABLE func1_AI_hi_alm_subcode
{
	LABEL		[limit_subcode];
	HELP		[limit_hi_subcode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE func1_AI_hi_alm_value
{
	LABEL		[limit_warn_value];
	HELP		[limit_hi_warn_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}

VARIABLE func1_AI_lo_alm_unacknowledged
{
	LABEL		[limit_warn_unacknowledged];
	HELP		[limit_warn_unacknowledged_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE func1_AI_lo_alm_state
{
	LABEL		[limit_state];
	HELP		[limit_lo_state_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0,	[limit_state_NO_WARNING]	},
		{	1,	[limit_state_LO]		}
	}
	HANDLING	READ;
}

VARIABLE func1_AI_lo_alm_time_stamp
{
	LABEL		[limit_time_stamp];
	HELP		[limit_time_stamp_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		TIME;
	HANDLING	READ;
}

VARIABLE func1_AI_lo_alm_subcode
{
	LABEL		[limit_subcode];
	HELP		[limit_lo_subcode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE func1_AI_lo_alm_value
{
	LABEL		[limit_warn_value];
	HELP		[limit_lo_warn_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}

VARIABLE func1_AI_lo_lo_alm_unacknowledged
{
	LABEL		[limit_alarm_unacknowledged];
	HELP		[limit_alarm_unacknowledged_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE func1_AI_lo_lo_alm_state
{
	LABEL		[limit_state];
	HELP		[limit_lo_lo_state_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0,	[limit_state_NO_ALARM]		},
		{	1,	[limit_state_LO_LO]		}
	}
	HANDLING	READ;
}

VARIABLE func1_AI_lo_lo_alm_time_stamp
{
	LABEL		[limit_time_stamp];
	HELP		[limit_time_stamp_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		TIME;
	HANDLING	READ;
}

VARIABLE func1_AI_lo_lo_alm_subcode
{
	LABEL		[limit_subcode];
	HELP		[limit_lo_lo_subcode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE func1_AI_lo_lo_alm_value
{
	LABEL		[limit_alarm_value];
	HELP		[limit_lo_lo_alarm_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}

VARIABLE func1_AI_simulate_value
{
	LABEL		[func_simulate_value];
	HELP		[func_ai_simulate_value_help];
	CLASS		CONTAINED & SERVICE;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
        	DISPLAY_FORMAT  FIND_PV_DISPLAY_FORMAT(func1_AI_channel)
	}
	HANDLING	READ & WRITE;
//    	CONSTANT_UNIT   FIND_DEFAULT_UNIT(func1_AI_channel);
}

VARIABLE func1_AI_simulate_status
{
	LABEL		[func_simulate_value_with_status_quality];
	HELP		[func_simulate_status_help];
	CLASS		CONTAINED & SERVICE;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0x20;
		__FF_STATUS_VALUES
	}
	HANDLING	READ & WRITE;
}

VARIABLE func1_AI_simulation_enabled
{
	LABEL		[func_simulation_enabled];
	HELP		[func_simulation_enabled_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0,	[disabled]	},
		{	1,	[enabled]	}
	}
	HANDLING	READ & WRITE;
}

VARIABLE func1_AI_out_unit_text
{
	LABEL		[func_out_unit_text] ;
	HELP		[func_out_unit_text_help] ;
	CLASS		CONTAINED ;
    	TYPE	        ASCII(16)
    	{
//req15_01_07    	    DEFAULT_VALUE   FIND_DEFAULT_UNIT(func1_AI_channel);
    	    DEFAULT_VALUE   "        ";
    	}
    	HANDLING    READ & WRITE;
//req15_01_07    	VALIDITY    IF (func1_AI_lin_type  == 1) { TRUE; } ELSE { FALSE; }
    	VALIDITY    IF (func1_AI_out_unit  == 1995) { TRUE; } ELSE { FALSE; }
}


//*********************************************************************
//    Unit relations
//*********************************************************************

// Function Block 1:

UNIT FUNC1_AI_OUT_UNIT
{
	func1_AI_out_unit:
    	func1_AI_out_value,
	func1_AI_out_upper_range_value,
	func1_AI_out_lower_range_value,
	func1_AI_hi_hi_lim,
	func1_AI_hi_lim,
	func1_AI_lo_lim,
	func1_AI_lo_lo_lim,
	func1_AI_hi_hi_alm_value,
	func1_AI_hi_alm_value,
	func1_AI_lo_alm_value,
	func1_AI_lo_lo_alm_value,
	func1_AI_alarm_hys
}

//*********************************************************************
//    Function Block 1: MENUs
//*********************************************************************

MENU Tab_s_func1
{
	LABEL		DEF_LABEL_FUNC1_AI;
	ITEMS
	{
        	func1_AI_st_rev,
		func1_AI_target_mode,
        	func1_AI_channel,
//req15_01_07        	func1_AI_lin_type,
        	func1_AI_out_unit,
        	func1_AI_out_unit_text,
        	func1_AI_out_decimal_point,
        	func1_AI_pv_ftime,
        	Tab_s_func1_pv_range,
		Tab_s_func1_outscale,
		Tab_s_func1_limits
	}
}


MENU Tab_m_func1
{
	LABEL		DEF_LABEL_FUNC1_AI;
	ITEMS
	{
        	func1_AI_st_rev,
		func1_AI_target_mode        (READ_ONLY),
		func1_AI_channel            (READ_ONLY),
//req15_01_07        	func1_AI_lin_type           (READ_ONLY),
        	func1_AI_out_unit           (READ_ONLY),
        	func1_AI_out_unit_text      (READ_ONLY),
        	func1_AI_out_decimal_point  (READ_ONLY),
        	func1_AI_pv_ftime           (READ_ONLY),
        	Tab_m_func1_pv_range,
		Tab_m_func1_outscale,
		Tab_m_func1_limits
	}
}


MENU Tab_s_func1_pv_range
{
	LABEL		[menu_input_measwindow];
	ITEMS
	{
        	func1_AI_pv_upper_range_value,
        	func1_AI_pv_lower_range_value
	}
}

MENU Tab_m_func1_pv_range
{
	LABEL		[menu_input_measwindow];
	ITEMS
	{
        	func1_AI_pv_upper_range_value   (READ_ONLY),
        	func1_AI_pv_lower_range_value   (READ_ONLY),
	}
}

MENU Tab_s_func1_outscale
{
	LABEL		[menu_output_scalewindow];
	ITEMS
	{
        	func1_AI_out_upper_range_value,
        	func1_AI_out_lower_range_value
	}
}

MENU Tab_m_func1_outscale
{
	LABEL		[menu_output_scalewindow];
	ITEMS
	{
        	func1_AI_out_upper_range_value  (READ_ONLY),
        	func1_AI_out_lower_range_value  (READ_ONLY)
	}
}

MENU Tab_s_func1_limits
{
	LABEL		[menu_output_limits];
	ITEMS
	{
		func1_AI_hi_hi_lim,
		func1_AI_hi_lim,
		func1_AI_lo_lim,
		func1_AI_lo_lo_lim,
		func1_AI_alarm_hys
	}
}

MENU Tab_m_func1_limits
{
	LABEL		[menu_output_limits];
	ITEMS
	{
		func1_AI_hi_hi_lim	(READ_ONLY),
		func1_AI_hi_lim		(READ_ONLY),
		func1_AI_lo_lim		(READ_ONLY),
		func1_AI_lo_lo_lim	(READ_ONLY),
		func1_AI_alarm_hys	(READ_ONLY)
	}
}

//*********************************************************************
//    Function Block : Online-Windows
//*********************************************************************

MENU Page_display_out_func1_AI
{
	LABEL		[func1_AI_out];
	ITEMS {
            func1_AI_channel              (READ_ONLY),
	    BarVal_out_display_func1_AI,
	    func1_AI_out_status
	  }
}

MENU BarVal_out_display_func1_AI
{
	LABEL		[func_out_value];
	ITEMS {
	    func1_AI_out_value              (READ_ONLY),
	    func1_AI_out_lower_range_value	(READ_ONLY),
	    func1_AI_out_upper_range_value	(READ_ONLY)
	  }
}














//-----------------
MENU OnlineWindow_S_alarm_func1_AI
{
	LABEL		DEF_LABEL_FUNC1_AI;
	ITEMS
	{
		Page_alarm_sum_func1_AI,
		Page_alarm_hi_hi_alm_func1_AI,
		Page_alarm_hi_alm_func1_AI,
		Page_alarm_lo_alm_func1_AI,
		Page_alarm_lo_lo_alm_func1_AI
	}
}

MENU Page_alarm_sum_func1_AI
{
//req22_12	LABEL		[kn_fb1_analysis]+" "+[menu_dialog_alarm_sum];
	LABEL		[menu_dialog_alarm_sum];
	ITEMS
	{
		func1_AI_current_state_alarm_sum,
		func1_AI_unreported_state_alarm_sum
	}
}

MENU Page_alarm_hi_hi_alm_func1_AI
{
	LABEL		[limit_hi_hi];
	ITEMS
	{
		func1_AI_hi_hi_alm_unacknowledged,
		func1_AI_hi_hi_alm_state,
		// func1_AI_hi_hi_alm_time_stamp,
		func1_AI_hi_hi_alm_subcode,
		func1_AI_hi_hi_lim		(READ_ONLY),
		func1_AI_hi_hi_alm_value
	}
}

MENU Page_alarm_hi_alm_func1_AI
{
	LABEL		[limit_hi];
	ITEMS
	{
		func1_AI_hi_alm_unacknowledged,
		func1_AI_hi_alm_state,
		// func1_AI_hi_alm_time_stamp,
		func1_AI_hi_alm_subcode,
		func1_AI_hi_lim		(READ_ONLY),
		func1_AI_hi_alm_value
	}
}

MENU Page_alarm_lo_alm_func1_AI
{
	LABEL		[limit_lo];
	ITEMS
	{
		func1_AI_lo_alm_unacknowledged,
		func1_AI_lo_alm_state,
		// func1_AI_lo_alm_time_stamp,
		func1_AI_lo_alm_subcode,
		func1_AI_lo_lim		(READ_ONLY),
		func1_AI_lo_alm_value
	}
}

MENU Page_alarm_lo_lo_alm_func1_AI
{
	LABEL		[limit_lo_lo];
	ITEMS
	{
		func1_AI_lo_lo_alm_unacknowledged,
		func1_AI_lo_lo_alm_state,
		func1_AI_lo_lo_alm_subcode,
		func1_AI_lo_lo_lim		(READ_ONLY),
		func1_AI_lo_lo_alm_value
	}
}

MENU Page_diagnosis_func1_AI_block
{
	LABEL		DEF_LABEL_FUNC1_AI;
	ITEMS
	{
		func1_AI_blk_object,
		func1_AI_blk_parent_class,
		func1_AI_blk_class,
		dummy_blk_dd_reference		(READ_ONLY),
		dummy_blk_dd_rev		(READ_ONLY),
		func1_AI_blk_profile,
		func1_AI_blk_profile_rev,
		func1_AI_st_rev,
		func1_AI_actual_mode
	}
}

//*********************************************************************
//    Function Block : Online-Dialogs
//*********************************************************************

MENU OnlineDialog_simulation_func1_AI
{
	LABEL		DEF_LABEL_FUNC1_AI;
	ITEMS
	{
		Page_simulation_input_func1_AI,
		Page_simulation_output_func1_AI
	}
}

MENU Page_simulation_input_func1_AI
{
	LABEL		[menu_dialog_simulation_input];
	ITEMS
	{
		func1_AI_simulation_enabled,
		Group_simulate_input_func1_AI
//req18_01_07		method_set
	}
}

MENU Group_simulate_input_func1_AI
{
	LABEL		[func_simulate_value];
	ITEMS
	{
		func1_AI_simulate_value,
		func1_AI_simulate_status
	}
}

MENU Page_simulation_output_func1_AI
{
	LABEL		[menu_dialog_simulation_output];
	ITEMS
	{
		func1_AI_target_mode,
		func1_AI_actual_mode,
		Group_simulate_output_func1_AI
//req18_01_07		method_set
	}
}

MENU Group_simulate_output_func1_AI
{
	LABEL		[func_out_value];
	ITEMS
	{
		func1_AI_out_value,
		func1_AI_out_status,
	}
}

//---------------------------------------------------------------------
//    Function Block 1:  Analog Input
//---------------------------------------------------------------------

COMMAND read_func1_AI_blk
{
	BLOCK function_block_1;
	INDEX 0;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_blk_reserve, func1_AI_blk_object, func1_AI_blk_parent_class, func1_AI_blk_class,
			func1_AI_blk_dd_reference, func1_AI_blk_dd_rev, func1_AI_blk_profile, func1_AI_blk_profile_rev,
			func1_AI_blk_execution_time, func1_AI_blk_num_parameters, func1_AI_blk_index_view_1,
			func1_AI_blk_num_view_lists  //req22_12, func1_AI_dummy
		}
	}
}

COMMAND read_func1_AI_st_rev
{
	BLOCK function_block_1;
	INDEX 1;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_st_rev
		}
	}
}

COMMAND read_func1_AI_tag_desc
{
	BLOCK function_block_1;
	INDEX 2;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_tag_desc
		}
	}
}

COMMAND write_func1_AI_tag_desc
{
	BLOCK function_block_1;
	INDEX 2;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_tag_desc
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_strategy
{
	BLOCK function_block_1;
	INDEX 3;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_strategy
		}
	}
}

COMMAND write_func1_AI_strategy
{
	BLOCK function_block_1;
	INDEX 3;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_strategy
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_alert_key
{
	BLOCK function_block_1;
	INDEX 4;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_alert_key
		}
	}
}

COMMAND write_func1_AI_alert_key
{
	BLOCK function_block_1;
	INDEX 4;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_alert_key
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_target_mode
{
	BLOCK function_block_1;
	INDEX 5;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_target_mode
		}
	}
}

COMMAND write_func1_AI_target_mode
{
	BLOCK function_block_1;
	INDEX 5;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_target_mode
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_mode
{
	BLOCK function_block_1;
	INDEX 6;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_actual_mode, func1_AI_permitted_mode, func1_AI_normal_mode
		}
	}
}

COMMAND read_func1_AI_alarm
{
	BLOCK function_block_1;
	INDEX 7;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_current_state_alarm_sum, func1_AI_unacknowledged_state_alarm_sum,
			func1_AI_unreported_state_alarm_sum, func1_AI_disabled_state_alarm_sum
		}
	}
}

//---------------------------------------------------------------------
//    Function Block 1:  Analog Input	Additional Parameter
//---------------------------------------------------------------------
COMMAND read_func1_AI_out
{
	BLOCK function_block_1;
	INDEX 10;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY		// DS-33
		{
			func1_AI_out_value,
			func1_AI_out_status
		}
	}
}

COMMAND write_func1_AI_out
{
	BLOCK function_block_1;
	INDEX 10;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_out_value,
			func1_AI_out_status
		}
		REPLY		// DS-33
		{
		}
	}
}

COMMAND read_func1_AI_pv_scale
{
	BLOCK function_block_1;
	INDEX 11;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY		// Array 2x float
		{
			func1_AI_pv_upper_range_value, func1_AI_pv_lower_range_value
		}
	}
}

COMMAND write_func1_AI_pv_scale
{
	BLOCK function_block_1;
	INDEX 11;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST		// Array 2x float
		{
			func1_AI_pv_upper_range_value, func1_AI_pv_lower_range_value
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_out_scale
{
	BLOCK function_block_1;
	INDEX 12;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY		// DS-36
		{
			func1_AI_out_upper_range_value,	func1_AI_out_lower_range_value,
			func1_AI_out_unit, func1_AI_out_decimal_point
		}
	}
}

COMMAND write_func1_AI_out_scale
{
	BLOCK function_block_1;
	INDEX 12;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST		// DS-36
		{
			func1_AI_out_upper_range_value, func1_AI_out_lower_range_value,
			func1_AI_out_unit, func1_AI_out_decimal_point
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_lin_type
{
	BLOCK function_block_1;
	INDEX 13;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_lin_type
		}
	}
}

COMMAND write_func1_AI_lin_type
{
	BLOCK function_block_1;
	INDEX 13;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_lin_type
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_channel
{
	BLOCK function_block_1;
	INDEX 14;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_channel
		}
	}
}

COMMAND write_func1_AI_channel
{
	BLOCK function_block_1;
	INDEX 14;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_channel
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_pv_ftime
{
	BLOCK function_block_1;
	INDEX 16;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_pv_ftime
		}
	}
}

COMMAND write_func1_AI_pv_ftime
{
	BLOCK function_block_1;
	INDEX 16;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_pv_ftime
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_alarm_hys
{
	BLOCK function_block_1;
	INDEX 19;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_alarm_hys
		}
	}
}

COMMAND write_func1_AI_alarm_hys
{
	BLOCK function_block_1;
	INDEX 19;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_alarm_hys
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_hi_hi_lim
{
	BLOCK function_block_1;
	INDEX 21;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_hi_hi_lim
		}
	}
}

COMMAND write_func1_AI_hi_hi_lim
{
	BLOCK function_block_1;
	INDEX 21;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_hi_hi_lim
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_hi_lim
{
	BLOCK function_block_1;
	INDEX 23;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_hi_lim
		}
	}
}

COMMAND write_func1_AI_hi_lim
{
	BLOCK function_block_1;
	INDEX 23;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_hi_lim
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_lo_lim
{
	BLOCK function_block_1;
	INDEX 25;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_lo_lim
		}
	}
}

COMMAND write_func1_AI_lo_lim
{
	BLOCK function_block_1;
	INDEX 25;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_lo_lim
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_lo_lo_lim
{
	BLOCK function_block_1;
	INDEX 27;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_lo_lo_lim
		}
	}
}

COMMAND write_func1_AI_lo_lo_lim
{
	BLOCK function_block_1;
	INDEX 27;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_lo_lo_lim
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_hi_hi_alm
{
	BLOCK function_block_1;
	INDEX 30;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY		// DS-39
		{
			func1_AI_hi_hi_alm_unacknowledged, func1_AI_hi_hi_alm_state,
			func1_AI_hi_hi_alm_time_stamp, func1_AI_hi_hi_alm_subcode,
			func1_AI_hi_hi_alm_value
		}
	}
}

COMMAND read_func1_AI_hi_alm
{
	BLOCK function_block_1;
	INDEX 31;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY		// DS-39
		{
			func1_AI_hi_alm_unacknowledged, func1_AI_hi_alm_state,
			func1_AI_hi_alm_time_stamp, func1_AI_hi_alm_subcode,
			func1_AI_hi_alm_value
		}
	}
}

COMMAND read_func1_AI_lo_alm
{
	BLOCK function_block_1;
	INDEX 32;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY		// DS-39
		{
			func1_AI_lo_alm_unacknowledged, func1_AI_lo_alm_state,
			func1_AI_lo_alm_time_stamp, func1_AI_lo_alm_subcode,
			func1_AI_lo_alm_value
		}
	}
}

COMMAND read_func1_AI_lo_lo_alm
{
	BLOCK function_block_1;
	INDEX 33;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY		// DS-39
		{
			func1_AI_lo_lo_alm_unacknowledged, func1_AI_lo_lo_alm_state,
			func1_AI_lo_lo_alm_time_stamp, func1_AI_lo_lo_alm_subcode,
			func1_AI_lo_lo_alm_value
		}
	}
}

COMMAND read_func1_AI_simulate
{
	BLOCK function_block_1;
	INDEX 34;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY		// DS-50
		{
			func1_AI_simulate_status,
			func1_AI_simulate_value,
			func1_AI_simulation_enabled
		}
	}
}

COMMAND write_func1_AI_simulate
{
	BLOCK function_block_1;
	INDEX 34;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST		// DS-50
		{
			func1_AI_simulate_status,
			func1_AI_simulate_value,
			func1_AI_simulation_enabled
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_out_unit_text
{
    BLOCK function_block_1;
    INDEX 35;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            func1_AI_out_unit_text
        }
    }
}

COMMAND write_func1_AI_out_unit_text
{
    BLOCK function_block_1;
    INDEX 35;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            func1_AI_out_unit_text
        }
        REPLY
        {
        }
    }
}
